/***
 * Excerpted from "Modern Systems Programming with Scala Native",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/rwscala for more book information.
***/
import scala.scalanative.unsafe._
import scala.scalanative.libc._
import stdio._

object main {
  def parseLine(line:CString):Unit = {
    var string_pointer:Ptr[CString] = stackalloc[CString]
    stdio.printf(c"allocated %d bytes for a string at %p\n",
                 sizeof[CString], string_pointer)
    val scanResult = stdio.sscanf(line, c"%s\n", string_pointer)
    if (scanResult < 1) {
      throw new Exception(s"insufficient matches in sscanf: $scanResult")
    }
    stdio.printf(c"scan results: '%s'\n", string_pointer)
  }

  def main(args:Array[String]):Unit = {
    val line_in_buffer = stackalloc[Byte](1024)
    val word_out_buffer = stackalloc[Byte](32)
    while (fgets(line_in_buffer, 1023, stdin) != null) {
      parseLine(line_in_buffer)
    }
  }
}
